<template>
  <div class="container" >
    <h1>Utilisateurs</h1>
    <div>
      <div class="float-right text-pad-right text-end">
        <router-link :to="{ name: 'userAdd'}" class="btn btn-outline-dark">ajouter un utilisateur</router-link><br>
      </div>
      <table class="table table-striped table-hover mb-5">
        <thead>
        <tr>
          <th scope="col">Nom</th>
          <th scope="col">Prénom</th>
          <th scope="col">Pseudo</th>
          <th scope="col">Email</th>
          <th scope="col">Roles</th>
          <th scope="col">#</th>
        </tr>
        </thead>
        <tbody>
        <user-item
            v-for="user in filteredUsers"
            :key="user.id"
            :id="user.id"
            :firstname="user.firstname"
            :lastname="user.lastname"
            :username="user.username"
            :email="user.email"
            :roles="user.roles"
        ></user-item>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>

import UserItem from "../../components/user/UserItem.vue";

export default {
  components: {
    UserItem,
  },
  data() {
    return {
      users: [],
      isLoading: false,
      error: null,
    };
  },
  computed: {
    filteredUsers() {
      return(this.$store.getters["users/users"]);
    },
    hasUsers() {
      return !this.isLoading && this.$store.getters["users/hasUsers"];
    },
  },
  created() {
    this.loadUsers();
  },
  methods: {
    async loadUsers(refresh = false) {
      this.isLoading = true;
      try {
        await this.$store.dispatch("users/loadUsers", {
          forceRefresh: refresh,
        });
      } catch (error) {
        this.error = error.message || "Something went wrong!";
      }
      this.isLoading = false;
    },

  },
  handleError() {
    this.error = null;
  },
};
</script>
